/*
 *  TOPPERS/ASP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Advanced Standard Profile Kernel
 * 
 *  Copyright (C) 2008-2011 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 *  Copyright (C) 2015-2016 by 3rd Designing Center
 *              Imageing System Development Division RICOH COMPANY, LTD.
 *  Copyright (C) 2016-2020 by TOPPERS PROJECT Educational Working Group.
 * 
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 * 
 *  @(#) $Id: target_serial.h 698 2020-03-23 16:50:59Z roi $
 */

/*
 *    ꥢI/OǥХSIO˥ɥ饤
 */

#ifndef TOPPERS_TARGET_SERIAL_H
#define TOPPERS_TARGET_SERIAL_H

/*
 *  åװ¸⥸塼stm32l476-nucleo64ѡ
 */

/*
 *  SIOGPIO
 */
#define TADR_U1_GPIO_BASE  TADR_GPIOA_BASE
#define TOFF_U1_APBNER     TOFF_RCC_APB1ENR1
#define ENABLE_U1_PORT     RCC_APB1ENR1_USART2EN
#define TOFF_U1_APBRSTR    TOFF_RCC_APB1RSTR1
#define RESET_U1_BIT       RCC_APB1RSTR1_USART2RST
#define ENABLE_U1_GPIO     RCC_AHB2ENR_GPIOAEN
#define TADR_U2_GPIO_BASE  TADR_GPIOA_BASE
#define TOFF_U2_APBNER     TOFF_RCC_APB2ENR
#define ENABLE_U2_PORT     RCC_APB2ENR_USART1EN
#define TOFF_U2_APBRSTR    TOFF_RCC_APB2RSTR
#define RESET_U2_BIT       RCC_APB2RSTR_USART1RST
#define ENABLE_U2_GPIO     RCC_AHB2ENR_GPIOAEN
#define TX1_PINPOS         2
#define RX1_PINPOS         3
#define TX2_PINPOS         9
#define RX2_PINPOS         10

#define GPIO_U1_AF         0x07U		/* AF7: USART2 Alternate Function mapping */
#define GPIO_U2_AF         0x07U		/* AF7: USART1 Alternate Function mapping */
#define U1_GPIOSPEED       GPIO_OSPEEDER_OSPEEDR2
#define U2_GPIOSPEED       GPIO_OSPEEDER_OSPEEDR2
#define U1_SRCINDEX        2
#define U2_SRCINDEX        0

/*
 *  SIOΥ١ɥ쥹
 */
#define USART1_BASE        TADR_USART2_BASE
#define USART2_BASE        TADR_USART1_BASE

/*
 *  ꥢI/Oݡȿ
 */
#ifndef TNUM_SIOP
#define TNUM_SIOP       2			/* ݡȤ륷ꥢI/OݡȤο */
#endif

/*
 *  SIOγߥϥɥΥ٥ֹ
 */
#define INHNO_SIO1      IRQ_VECTOR_USART2
#define INTNO_SIO1      IRQ_VECTOR_USART2
#define INHNO_SIO2      IRQ_VECTOR_USART1
#define INTNO_SIO2      IRQ_VECTOR_USART1

#define INTPRI_SIO       -3        /* ͥ */
#define INTATR_SIO       0         /* ° */


#include "arm_m_gcc/stm32l4xx/chip_serial.h"

#endif /* TOPPERS_TARGET_SERIAL_H */
